// Form1.cpp

#include "stdafx.h"

#include "Form1.h"
#include "WndMessageHolder.h"

using namespace BringUpTest;

// Message handler for primary instance activation

void Form1::WndProc(Message %msg)
{
  if (msg.Msg == WndMessageHolder::GetInstance()->WM_BRINGUP) BringMeUp();
  __super::WndProc(msg);
}

// Handles WM_BRINGUP message

// Uncomment this to use alternative function version:
// #define USE_ALTERNATIVE

#ifndef USE_ALTERNATIVE

// "Classic" version according to TheGreatCthulhu's suggestion - unfortunately doesn't
// really work completely... (see CG forum thread)

void Form1::BringMeUp()
{
  if (WindowState == FormWindowState::Minimized)
    WindowState = FormWindowState::Normal;

  Activate();
}

#else

// Alternative version - works but unfortunately looks hackish...

void Form1::BringMeUp()
{
  if (WindowState != FormWindowState::Minimized)
    WindowState = FormWindowState::Minimized;
  WindowState = FormWindowState::Normal;
  // Activate();
}

#endif
